/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CONCORRENTE                                              */
/* Tabela : CONCORRENTE                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 17/08/2004 - Welbert G. Moitinha                                           */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CONCORRENTE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CONCORRENTE
GO

CREATE TRIGGER DTULTATU_CONCORRENTE
ON CONCORRENTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONCORRENTE', null, 'CDCONCORRENT=' + CDCONCORRENT + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONCORRENTE
      SET DTULTATUCONC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CONCORRENTE.CDCONCORRENT,0) = ISNULL(INSERTED.CDCONCORRENT,0)) AND
            (ISNULL(CONCORRENTE.NMCONCORRENT,0) = ISNULL(INSERTED.NMCONCORRENT,0)) ;
   END;
END;
GO
