--Trigger responsvel por bloquear a retirada caso o lote esteja vencido
IF EXISTS(SELECT
             NAME
          FROM
             SYSOBJECTS
          WHERE
             NAME = 'VD_LOTE_VENCIDO' AND
             TYPE = 'TR')

DROP TRIGGER VD_LOTE_VENCIDO
GO

CREATE TRIGGER VD_LOTE_VENCIDO
ON ITLANCTOEST
FOR INSERT

AS

DECLARE @V_NEW_CDFILIAL     VARCHAR(04);
DECLARE @V_NEW_NRLOTEESTQ   VARCHAR(20);
DECLARE @V_NEW_NRSUBLOTE    VARCHAR(04);
DECLARE @V_NEW_CDPRODUTO    VARCHAR(10);
DECLARE @V_DTVALILOTE       DATETIME;
DECLARE @V_RETIRADA         NUMERIC;
DECLARE @V_NMPRODUTO        VARCHAR(50);

BEGIN

   DECLARE C_INSLANCEST CURSOR FOR
   SELECT CDFILIAL,   NRLOTEESTQ, NRSUBLOTE,    CDPRODUTO
   FROM INSERTED
   WHERE (CDFILIAL+NRLANCESTQ) NOT IN (SELECT CDFILIAL+NRLANCESTQ
                                       FROM DELETED);

   OPEN C_INSLANCEST;

   FETCH NEXT FROM C_INSLANCEST INTO @V_NEW_CDFILIAL,   @V_NEW_NRLOTEESTQ,
                                     @V_NEW_NRSUBLOTE,  @V_NEW_CDPRODUTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
   
      SELECT @V_IDUTCTRLLOTE = IDUTCTRLLOTE
        FROM PRODFILI
       WHERE (CDFILIAL  = @V_NEW_CDFILIAL )
         AND (CDPRODUTO = @V_NEW_CDPRODUTO);
         
      --RETIRADA   
      IF ((@V_NEW_IDTIPOMOVI = '3') AND (@V_IDUTCTRLLOTE = 'S')) BEGIN
         SELECT @V_RETIRADA = COUNT(*)
           FROM LOTITRETIEST L
          WHERE (L.NRLANCESTQ IS NULL            )
            AND (L.CDFILIAL   = @V_NEW_CDFILIAL  )
            AND (L.CDPRODUTO  = @V_NEW_CDPRODUTO )
            AND (L.NRLOTEESTQ = @V_NEW_NRLOTEESTQ)
            AND (L.NRSUBLOTE  = @V_NEW_NRSUBLOTE );
               
         IF (@V_RETIRADA > 0) BEGIN
            SELECT @V_DTVALILOTE = L.DTVALILOTE,
                   @V_NMPRODUTO  = P.NMPRODUTO
              FROM LOTE L INNER JOIN PRODUTO P ON (L.CDPRODUTO = P.CDPRODUTO)
             WHERE (L.CDFILIAL   = @V_NEW_CDFILIAL  )
               AND (L.CDPRODUTO  = @V_NEW_CDPRODUTO )
               AND (L.NRLOTEESTQ = @V_NEW_NRLOTEESTQ)
               AND (L.NRSUBLOTE  = @V_NEW_NRSUBLOTE );
               
            IF (TRUNC(@V_DTVALILOTE) < TRUNC(GETDATE())) BEGIN
               RAISE_APPLICATION_ERROR(-20501, '_ Produto '+@V_NMPRODUTO+' com Lote Vencido: '+@V_NEW_NRLOTEESTQ+' - '+@V_DTVALILOTE+' _');
            END;
         END;
      END;

      FETCH NEXT FROM C_INSLANCEST INTO @V_NEW_CDFILIAL,   @V_NEW_NRLOTEESTQ,
                                        @V_NEW_NRSUBLOTE,  @V_NEW_CDPRODUTO;
   END;

   CLOSE C_INSLANCEST;
   DEALLOCATE C_INSLANCEST;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'VD_LOTE_VENCIDO','6.05.xxx';
GO

